<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="98px">
		    <el-form-item label="生产时间段" prop="productDateArray">
                <el-date-picker
				v-model="queryParams.productDateArray"
				format="yyyy-MM-dd HH:mm:00"
				type="datetimerange"
				range-separator="至"
				start-placeholder="开始日期"
				end-placeholder="结束日期">
				</el-date-picker>
			</el-form-item>
			<el-form-item label="班次" prop="shiftId">
				<el-select v-model="queryParams.shiftId" placeholder="请选择班次" clearable>
					<el-option v-for="item in workShift" :key="item.shiftId" :label="item.shiftDesc"
								:value="item.shiftId"
						></el-option>
				</el-select>
			</el-form-item>
			<el-form-item label="工单编号" prop="workorderCode">
				<el-input
					v-model="queryParams.workorderCode"
					placeholder="请输入工单编号"
					clearable
				/>
			</el-form-item>
			<el-form-item label="订单编码" prop="orderCode">
				<el-input
					v-model="queryParams.orderCode"
					placeholder="请输入订单编号"
					clearable
				/>
			</el-form-item>
			<el-form-item label="产品编号" prop="productCode">
				<el-input
					v-model="queryParams.productCode"
					placeholder="请输入产品编码"
					clearable
				/>
			</el-form-item>
			<el-form-item label="产品名称" prop="productName">
				<el-input
					v-model="queryParams.productName"
					placeholder="请输入产品名称"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item label="设备名称" prop="equName">
				<el-input
					v-model="queryParams.equName"
					placeholder="请输入设备名称"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>

			<el-form-item>
				<el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
				<el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button
					type="warning"
					plain
					icon="el-icon-download"
					size="mini"
					@click="handleExport"
				>导出</el-button>
			</el-col>
			<right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>

		<el-table v-loading="loading" :data="hourProList"
		  :summary-method="getSummaries"
          show-summary
		>
		    <el-table-column label="设备编码" align="center" prop="equCode" min-width="100" />
            <el-table-column label="设备名称" align="center" prop="equName" min-width="100" />
			<el-table-column label="设备总产量" align="center" prop="quantity" min-width="100" />
            <template v-for="(column, index) in showTitles">
                <el-table-column align="center" min-width="120" :prop="column.id" :key="column.id" :label="column.titleName"/>
            </template>
		</el-table>
	</div>
</template>

<script>
import {getHourProductionTitle, getHourProductionList,getProShifts} from "@/api/mes/reportWork";

import moment from 'moment';
export default {
	name: "Prepare",
	data() {
		return {
			// 遮罩层
			loading: true,
			// 选中数组
			ids: [],
			// 非单个禁用
			single: true,
			// 非多个禁用
			multiple: true,
			// 显示搜索条件
			showSearch: true,
			// 备料单表格数据
			hourProList: [],

            showTitles:[],//列表展示的小时段

			// 弹出层标题
			title: "",
			// 是否显示弹出层
			open: false,
			// 查询参数
			queryParams: {
				productDateArray: [],
				pageNum: 1,
				pageSize: 10,
				workorderCode: null,
				workorderName: null,
				parentOrder: null,
				orderId: null,
				orderCode: null,
				productId: null,
				productCode: null,
				prodType: null,
				productName: null,
				productSpc: null,
				productDate: null,
			},
			// 表单参数
			form: {},
			// 班次list
            workShift: []
		};
	},
	created() {
        this.getDate();
		this.getList();

		// 获取班次信息
		getProShifts().then(response => {
			this.workShift = response.data
		})
	},
	methods: {
        /**获取默认查询时间段**/
		getDate() {
			let start = this.Fungetdate (0)
			let end = this.Fungetdate (1)
			this.queryParams.productDateArray.push(start,end)
		},
		Fungetdate (num) {
			var dd = new Date();
			dd.setDate(dd.getDate() + num);
			var y = dd.getFullYear();
			var m = dd.getMonth() + 1;//获取当前月份的日期
			var d = dd.getDate();
			return y + "-" + m + "-" + d+" 00:00:00";
		},

		/** 查询设备小时产量列表 */
		getList() {
			if(this.queryParams.productDateArray!=null){
				this.queryParams.productDateStart = moment(this.queryParams.productDateArray[0]).format('YYYY-MM-DD HH:mm:00');
				this.queryParams.productDateEnd = moment(this.queryParams.productDateArray[1]).format('YYYY-MM-DD HH:mm:00');
			}
			
			this.loading = true;
            //获取Table表头
			getHourProductionTitle(this.queryParams).then(response => {
				this.showTitles = [];
				for(let i=0;i<=response.length-1;i++){
					var pobj={};
					pobj.id="hourPro"+i;
					pobj.titleName = response[i]+"时";
					this.showTitles.push(pobj)
				}
			});
            //获取Table数据
			getHourProductionList(this.queryParams).then(response => {
				this.hourProList = response;
				this.loading = false;
			});
		},
		// 取消按钮
		cancel() {
			this.open = false;
			this.reset();
		},
		// 表单重置
		reset() {
			this.form = {
				prepareId: null,
				workorderCode: null,
				workorderName: null,
				parentOrder: null,
				orderId: null,
				orderCode: null,
				productId: null,
				productCode: null,
				prodType: null,
				productName: null,
				productSpc: null,
				wetDetailPlanId: null,
				productDate: null,
				shiftId: null,
				ancestors: null,
				status: null,
				remark: null,
				attr1: null,
				attr2: null,
				attr3: null,
				attr4: null,
				createBy: null,
				createTime: null,
				updateBy: null,
				updateTime: null,
				factoryCode: null
			};
			this.resetForm("form");
		},
		/** 搜索按钮操作 */
		handleQuery() {
			this.queryParams.pageNum = 1;
			this.getList();
		},
		/** 重置按钮操作 */
		resetQuery() {
			this.resetForm("queryForm");
			this.handleQuery();
		},

		/** 导出按钮操作 */
		handleExport() {
			this.download('mes/reportWork/getHourProductionExport', {
				...this.queryParams
			}, `hourProduction_${new Date().getTime()}.xlsx`)
		},
		getSummaries(param) {
			const { columns, data } = param;
			const sums = [];
			columns.forEach((column, index) => {
				if (index === 0) {
					sums[index] = '合计';
					return;
				}
				const values = data.map(item => Number(item[column.property]));
				if (!values.every(value => isNaN(value))) {
					sums[index] = values.reduce((prev, curr) => {
					const value = Number(curr);
					if (!isNaN(value)) {
						return prev + curr;
					} else {
						return prev;
					}
					}, 0);
					sums[index] += '';
					if(sums[index]  > 1000000){
                      sums[index] = '';
					}
				} else {
					sums[index] = '';//N/A
				}
			});

			return sums;
		}
	}
};
</script>
